

$regfile = M48def.dat
$crystal = 8000000

Dim X As Byte

Dim Noant As Byte
Dim Ant1 As Byte
Dim Ant2 As Byte
Dim Ant3 As Byte
Dim Ant4 As Byte
Dim Ant5 As Byte
Dim Ant6 As Byte

Dim Band160 As Byte
Dim Band80 As Byte
Dim Band40 As Byte
Dim Band30 As Byte
Dim Band20 As Byte
Dim Band17 As Byte
Dim Band15 As Byte
Dim Band12 As Byte
Dim Band10 As Byte
Dim Band6 As Byte


Dim Vst As Byte
Dim Vst2 As Byte

Dim Volty As Word



Config Portb.0 = Output
Config Portb.1 = Output
Config Portb.2 = Output
Config Portb.3 = Output
Config Portb.4 = Output
Config Portb.5 = Output

Config Portd = Input
Config Portd.6 = Output
Config Portd.7 = Output

Config Portc.2 = Input
Set Portc.2


Rem konfigurace AD pevodnku
Config Adc = Single , Prescaler = Auto                      'nastaven ADC pevodnku

Set Portd.0
Set Portd.1
Set Portd.2
Set Portd.3
Set Portd.4
Set Portd.5
Reset Portd.6
Reset Portd.7

Reset Portb

Noant = &B00000000                                          ' kde je jednicka, tak tam je sepnute antenni rele
Ant1 = &B00000001
Ant2 = &B00000010
Ant3 = &B00000100
Ant4 = &B00001000
Ant5 = &B00010000
Ant6 = &B00100000

Band160 = 1                                                 ' pasmo na vstupu v BCD kodu
Band80 = 2
Band40 = 3
Band30 = 4
Band20 = 5
Band17 = 6
Band15 = 7
Band12 = 8
Band10 = 9
Band6 = 10

Vst2 = Band160                                              'pri prvnim (po resetu) prepnuti do manualniho rezimu se zapne pasmo 160m



Rem ************************************************

Decoder_bcd:

Do

    Vst = Pind And &B00001111


    If Vst = Band160 Then                                   'na radiu nastaveno 160m
    Waitms 10
    Portb = Ant1                                            'prepnout na tuto antenu
    Waitms 10

    Elseif Vst = Band80 Then                                'na radiu nastaveno 80m
    Waitms 10
    Portb = Ant2                                            'prepnout na tuto antenu
    Waitms 10

    Elseif Vst = Band40 Then                                'atd...
    Waitms 10
    Portb = Ant3
    Waitms 10

    Elseif Vst = Band30 Then
    Waitms 10
    Portb = Ant3
    Waitms 10

    Elseif Vst = Band20 Then
    Waitms 10
    Portb = Ant4
    Waitms 10

    Elseif Vst = Band17 Then
    Waitms 10
    Portb = Ant3
    Waitms 10

    Elseif Vst = Band15 Then
    Waitms 10
    Portb = Ant5
    Waitms 10

    Elseif Vst = Band12 Then
    Waitms 10
    Portb = Ant3
    Waitms 10

    Elseif Vst = Band10 Then
    Waitms 10
    Portb = Ant6
    Waitms 100

    Elseif Vst = Band6 Then
    Waitms 10
    Portb = Ant6
    Waitms 10

    Else
    Waitms 10
    Portb = Noant
    Waitms 10

    End If



    If Pind.5 = 0 Then                                      'pokud je stisknuto tlacitko na portu D.5, tak
    Gosub Man                                               ' skoc do manualniho rezimu
    End If

    If Pind.4 = 0 Then                                      'pokud je stisknuto tlacitko na portu D.4, tak
    Gosub Test                                              ' skoc na test vsech rele
    End If

    If Pinc.2 = 0 Then                                      'pokud je zkratovana propojna na pinu C.2, tak
    Exit Do                                                 'vyskoc ze smycky a ....
    End If

Loop

   Goto Komparator                                          '.... skoc do casti dekodovani pasma podle napeti (komparator)


Rem ************************ TEST - na 1/2 sec se sepnou postupne vsechna rele ***********************

Test:
Rem selftest po stisknuti tlacitka
Portb = Noant
   Waitms 100
   For X = 0 To 5
   Set Portb.x
   Waitms 500
   Reset Portb.x
   Waitms 500
   Next
 Return

Rem *************************** MAN: manualne tlacitkem  krokovani jednotlivych rele ********************

Man:                                                        'namualni prepinani anten

Portb = Noant                                               'nejprve odpoj vsechny anteny
Set Portd.6                                                 'rozsvit LED indikujici manualni rezim
Waitms 200                                                  'cekej 50 milisekund



 Do

   Select Case Vst2                                         'podle promenne Vst2 pripoj patricne rele
    Case 1 : Portb = Ant1
    Case 2 : Portb = Ant2
    Case 3 : Portb = Ant3
    Case 4 : Portb = Ant4
    Case 5 : Portb = Ant5
    Case 6 : Portb = Ant6
   End Select


   If Pind.4 = 0 Then                                       'pokud je stisknuto tlacitko na pinu D.4, tak
   Incr Vst2                                                'zvetsi promennou Vst2 o jednu
   Waitms 200                                               '
   End If

   If Vst2 > 6 Then                                         'pokud je promenna Vst2 vetsi nez 6, tak
   Vst2 = 1                                                 'ji vrat zpatky na 1
   End If

   If Pind.5 = 0 Then                                       'pokud je stisknuto tlacitko na portu D.5, tak
   Reset Portb                                              'odpoj vsechny anteny
   Reset Portd.6                                            ' zhasni LED indikujici manualni rezim
   Waitms 200                                               ' pockej 200 milisekund
   Exit Do
   End If                                                   ' vyskoc ze smycky a vrat se do automatickeho rezimu

 Loop

 Return


Rem ************************************************



Rem **************** prepinani anten podle napeti *************


Komparator:

Do

     Start Adc                                              'zapnut A/D pevodnku
     Volty = Getadc(5)                                      'zjitn hodnoty z pevodnku ADC0 a uloen do promnn "Volty"
     Stop Adc                                               'vypnut A/D pevodnku

Rem promenna volty neni ve skutecnosti napeti ve voltech,
Rem ale cislo ktere pri danem vstupnim napeti nacital AD prevodnik.

    If Volty > 41 And Volty < 94 Then                       'pokud je zmerena hodnota mezi 41 a 94 tak
    Waitms 10
    Portb = Ant1                                            'prepni na tuto antenu
    Waitms 10

    Elseif Volty > 110 And Volty < 164 Then                 'pokud je zmerena hodnota mezi 110 a 164 tak
    Waitms 10
    Portb = Ant2                                            'prepni na tuto antenu
    Waitms 10

    Elseif Volty > 178 And Volty < 231 Then                 'atd ...
    Waitms 10
    Portb = Ant3
    Waitms 10

    Elseif Volty > 315 And Volty < 368 Then
    Waitms 10
    Portb = Ant4
    Waitms 10

    Elseif Volty > 450 And Volty < 503 Then
    Waitms 10
    Portb = Ant5
    Waitms 10

    Elseif Volty > 587 And Volty < 640 Then
    Waitms 10
    Portb = Ant6
    Waitms 100

    Else                                                    ' pokud zmerena hodnota nevyhovuje zadne podmince vyse,tak
    Waitms 10
    Portb = Noant                                           ' odpoj jsechny antenni vstupy
    Waitms 10

    End If



    If Pind.5 = 0 Then                                      ' pokud je stisknuto tlacitko na pinu D.5
    Gosub Man                                               'tak odskok do manualniho prepinani
    End If

    If Pind.4 = 0 Then                                      'pokud je stisknuto tlacitko na pinu D.4
    Gosub Test                                              ' tak odskok na test vsech rele
    End If

    If Pinc.2 = 1 Then                                      'pokud je rozpojena propojka na pinu C.2
    Exit Do                                                 ' tak vyskocit ze smycky a
    End If

Loop
     Goto Decoder_bcd                                       ' skocit na  dekodovani ze vstupu BCD


End                                                         'end program